/*
 * P/ECE gm[ v1.00 main.c
 *
 * Copyright (c) 2001 Hiroshi Chonan. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Hiroshi Chonan
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <piece.h>
#include <muslib.h>

#include "mml.h"

unsigned char	vbuff[128*88];	/* VRAM obt@ */
unsigned char	tempo = 60;	/* e| */
unsigned long	prev_padinfo;	/* pbgԕۑp */
unsigned long	start_at;	/* ^C}l(ms)i[p */
unsigned long	tempo_val[300];	/* EFCgmsli[z */
unsigned char	l_c = 3;	/* o[̏Zx */
unsigned char	r_c = 0;	/* Eo[̏Zx */
unsigned char	sound = 1;	/* TEhtO */
unsigned char	beat = 0;	/* qݒl */
unsigned char	beat_c = 0;	/* ݂̔q */

/*
 * void disptempo(void) - e|l̕\XVMMLobt@̃e|ύX
 *
 * l: Ȃ
 * Ԓl: Ȃ
 *
 * : XVꂽe|lɂĕ\̕ύXMMLobt@̃e|
 *       ύXBe|lɂĂmml.hŎw肳ꂽ̏ꏊɂ
 *       ăe|l𒼐ڕύXBMMLf[^ύXꍇɂẮA
 *       ItZbĝŒӂKvB
 *
 */

void
disptempo()
{
	pceFontSetBkColor(0);
	pceFontSetTxColor(3);
	pceFontSetType(1);
	pceFontSetPos(80,16);
	pceFontPrintf("%3d",tempo);
	mml_beat[TEMPO_OFFSET]=tempo;
	mml_beat_h[TEMPO_OFFSET]=tempo;
	return;
}

/*
 * void dispbeat(void) - ql̕\XV
 *
 * l: Ȃ
 * Ԓl: Ȃ
 *
 * : ύXꂽqlʂɔfB
 *
 */
void
dispbeat()
{
	pceFontSetBkColor(0);
	pceFontSetTxColor(3);
	pceFontSetType(1);
	pceFontSetPos(80,34);
	pceFontPrintf("%3d",beat);
	return;
}

/*
 * void pceAppInit(void) - AvP[V̏ݒ
 *
 * l: Ȃ
 * Ԓl: Ȃ
 *
 * : AvP[V̊e평ݒsB
 *
 */
void
pceAppInit()
{
	int	i;

	/* ee|ɂEFCgmsľvZ */
	for ( i=30 ; i<=240 ; i++ ) {
		tempo_val[i] = 60000 / i; /* 1000ms * 60sec / BPM */
	}

	pceLCDDispStop();
	memset( vbuff, 0, 128*88 );	/* VRAM obt@̃NA */
	pceLCDSetBuffer( vbuff );	/* VRAM obt@̎w */
	pceLCDDispStart();
	
	/* etB[h̕` */
	pceLCDPaint( 3, 0,0,128,10);

	pceFontSetBkColor(3);
	pceFontSetTxColor(0);
	pceFontSetPos(0,0);
	pceFontPutStr("P/ECE gm[ v1.00");
	
	pceFontSetBkColor(0);
	pceFontSetTxColor(3);
	pceFontSetPos(24,58);
	pceFontPutStr("[A] ON/OFF");
	pceFontSetPos(24,69);
	pceFontPutStr("[B] q̐ؑ");

	pceFontSetType(1);
	pceFontSetPos(24,16);
	pceFontPutStr("Tempo :");
	pceFontSetPos(24,34);
	pceFontPutStr(" Beat :");

	disptempo();
	dispbeat();
	
	start_at = pceTimerGetCount();	/* mslL^ */

	pceLCDTrans();
	InitMusic();
	pceAppSetProcPeriod( 1 );	/* AppProc()  1msƂɃR[ */
	return;
}


/*
 * void pceAppProc(int cnt) - AvP[VvVW
 *
 * l: Ăяoꂽ(int cnt) (gpĂȂ)
 * Ԓl: Ȃ
 *
 * : IɃVXeR[(1ms)Ae폈sB
 *
 */
void
pceAppProc( cnt )
int cnt;
{
	unsigned char	draw=0;		/* `tO */
	unsigned long	padinfo;	/* pbh */
	unsigned long	now,tick;	/* mslp */

	now = pceTimerGetCount();	/* ݂msl擾 */
	tick = now - start_at;		/* oߎԂvZ */
	padinfo = pcePadGet();		/* pbh擾 */

	if ( tick >= tempo_val[tempo]) { /* q̃^C~O */
		start_at = now;	/* ݂mslJnmslɕۑ */

		/* Eo[̐F̔] 3 <-> 0 */
		l_c = ( l_c == 3 ) ? 0 : 3;
		r_c = ( r_c == 3 ) ? 0 : 3;

		/* Eo[̕`w */
		pceLCDPaint( l_c, 0,20,15,67);
		pceLCDPaint( r_c, 113,20,15,67);

		/* TEhtOĂA
		   Ȃe|ړ(pbg㉺)łȂꍇ */
		if ( sound && !(padinfo & (PAD_UP | PAD_DN))) {
			if (beat) { /* qݒ肪ꍇ */
				beat_c++;
				if ( beat_c >= beat ) {
					/* ߓɑꍇ
					   ቹ炷 */
					beat_c=0;
					PlayMusic(mml_beat);
				} else {
					/* ȊO͒ቹ */
					PlayMusic(mml_beat_h);
				}
			} else { /* q0̏ꍇ */
				/* ⓚpō炷 */
				PlayMusic(mml_beat_h);
			}
		}

		draw=1;
	}

	if ( tempo < 240 ) {	/* ݂̃e|240̏ꍇ */
		if ( padinfo & PAD_UP ) {
			/* pbhɂčیȂe|Abv() */
			tempo++;
			disptempo();
			draw=1;
		} else if ( !(prev_padinfo & PAD_RI ) && (padinfo & PAD_RI) ) {
			/* VɃpbhEꍇe|Abv(ᑬ) */
			tempo++;
			disptempo();
			draw=1;
		}
	}

	if ( tempo > 30 ) {	/* ݂̃e|30𒴂ꍇ */
		if (padinfo & PAD_DN) {
			/* pbhɂčیȂe|_E() */
			tempo--;
			disptempo();
			draw=1;
		} else if ( !(prev_padinfo & PAD_LF ) && (padinfo & PAD_LF) ) {
			/* VɃpbhꍇe|_E(ᑬ) */
			tempo--;
			disptempo();
			draw=1;
		}
	}

	/* V A {^ꂽ*/
	if ( !(prev_padinfo & PAD_A ) && ( padinfo & PAD_A ) ) {
		sound = sound ? 0 : 1;	/* TEhtO𔽓] */
	}
	
	/* V B {^ꂽ*/
	if ( !(prev_padinfo & PAD_B ) && ( padinfo & PAD_B ) ) {
		/* 0 -> 2 -> 3 -> 4 -> 6 -> 0 ̏Ŕqω */
		switch(beat) {
		case 0:
			beat = 2;
			break;
		case 2:
			beat = 3;
			break;
		case 3:
			beat = 4;
			break;
		case 4:
			beat = 6;
			break;
		case 6:
			beat = 0;
			break;
		default:
			/* ɂ͓BȂ */
			break;
		}
		dispbeat();	/* ql̕ύXf */
		draw = 1;	/* `tOグ */
	}

	prev_padinfo = padinfo;	/* pbh̑ޔ */
	
	if (draw) {	/* `tOオĂꍇɂ͉ʓ] */
		pceLCDTrans();
	}
	return;
}

/*
 * void pceAppExit(void) - Ȉ
 *
 * l: Ȃ
 * Ԓl: Ȃ
 *
 * : Ȉs
 *
 */
void
pceAppExit()
{
	memset( vbuff, 0, 128*88 );	/* VRAM obt@̃NA */
	pceLCDTrans();			/* VRAM ̓](NA */
	pceLCDDispStop();		/* LCD\̒~ */
	return;
}

/*
 * int pceAppNotify(int type, int param) - eʒm󂯂Ƃ̏
 *
 * l: ʒmbZ[W(int type), ʒmp[^(int param)
 * Ԓl: bZ[W(int)
 *
 * : VXej[̌ĂяoƃX^oC}(APPNR_REJECT)
 *
 */

int
pceAppNotify( type, param )
int	type;
int	param;
{
	switch(type) {
	case APPNF_SMSTART:		/* VXej[ďo */
		return APPNR_REJECT;
		break;
	case APPNF_STANDBY:		/* X^oC */
		return APPNR_REJECT;
		break;
	default:			/* LȊO */
		return APPNR_IGNORE;
		break;
	}
}
